<template>
  <div class="site-wrapper">
    <site-header :blog="blog" :header="header">
      <site-navigation slot="header"></site-navigation>
    </site-header>
    <component :is="content"></component>
    <site-footer />
  </div>
</template>


<script setup>
import { useStore } from 'vuex'
import { useThemeData } from '@vuepress/plugin-theme-data/lib/client'
import types from '../store/types'
const themeData = useThemeData()
</script>

<script>
import { mapActions, mapGetters } from "vuex";


import Post from './Post.vue'
import Page from './Page.vue'
import Posts from './Posts.vue'
import SiteHeader from '../components/Header.vue'
import SiteFooter from '../components/Footer.vue'
import SiteNavigation from '../components/Navigation.vue'

export default {
  components: { Page, Posts, Post, SiteFooter, SiteHeader, SiteNavigation },
  methods: {
    ...mapActions(["updateSite", "updatePage", "updateParams"]),
    updateLayoutClass() {
      this.$el.parentNode.className = `${this.type}-template`;
    },
  },
  computed: {
    ...mapGetters(["type", "blog", "header"]),

    content() {
      switch (this.type) {
        case "home":
        case "tags":
        case "posts":
        case "category":
          return "posts";
        case "post":
          return "post";
        case "page":
          return "page";
      }
    },
  },
  watch: {
    $page() {
      this.updatePage(this.$page);
      this.updateLayoutClass();
    },
    $route() {
      this.updateParams(this.$route.params);
      this.updateLayoutClass();
    },
  },
  mounted() {
    this.updateSite({site: this.$site, themeConfig: this.themeData});
    this.updatePage(this.$page);
    // TODO: Check this mutation
    this.updateParams(this.$route.params);
    this.updateLayoutClass();
  },
};
</script>

<style>
@import "../styles/global.css";
@import "../styles/screen.css";

/* Code section
  /* ---------------------------------------------------------- */
div[class^="language-"] {
  min-width: 100%;
  max-width: 100%;
}
.search-box input {
  width: 20rem;
}
</style>
